Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/RectangularPrimitiveBase.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/RectangularPrimitiveBase.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/RectangularPrimitiveBase.cs	(revision 13045)
@@ -41,17 +41,8 @@
     }
 
-    public string Text { get; set; }
-    public Font Font { get; set; }
-    public float MaximumFontSize { get; set; }
-
     protected RectangularPrimitiveBase(IChart chart, PointD lowerLeft, PointD upperRight)
       : base(chart) {
       selectionRectangles = new Group(chart);
       SetPosition(lowerLeft, upperRight);
-
-      MaximumFontSize = 12;
-    }
-    protected RectangularPrimitiveBase(IChart chart, double x1, double y1, double x2, double y2)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2)) {
     }
     protected RectangularPrimitiveBase(IChart chart, PointD lowerLeft, PointD upperRight, Pen pen, Brush brush)
@@ -59,7 +50,4 @@
       selectionRectangles = new Group(chart);
       SetPosition(lowerLeft, upperRight);
-    }
-    protected RectangularPrimitiveBase(IChart chart, double x1, double y1, double x2, double y2, Pen pen, Brush brush)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2), pen, brush) {
     }
 
@@ -70,11 +58,87 @@
       myLowerLeft = lowerLeft;
       myUpperRight = upperRight;
-      OnUpdate();
+      OnRedrawRequired();
     }
-    public void SetPosition(double x1, double y1, double x2, double y2) {
-      SetPosition(new PointD(x1, y1), new PointD(x2, y2));
-    }
+
     public override void Move(Offset delta) {
       SetPosition(LowerLeft + delta, UpperRight + delta);
+    }
+
+    public override void Move(PointD point, Offset delta) {
+      if (Selected && selectionRectangles.ContainsPoint(point)) {
+        var rect = (SelectionRectangle)selectionRectangles.GetPrimitive(point);
+        var point1 = PointD.Empty;
+        var point2 = PointD.Empty;
+        if (rect.Point == LowerLeft) {
+          point1 = LowerLeft + delta;
+          point2 = UpperRight;
+        } else if (rect.Point == UpperRight) {
+          point1 = LowerLeft;
+          point2 = UpperRight + delta;
+        } else if (rect.Point.X == LowerLeft.X && rect.Point.Y == UpperRight.Y) {
+          point1 = new PointD(LowerLeft.X + delta.DX, LowerLeft.Y);
+          point2 = new PointD(UpperRight.X, UpperRight.Y + delta.DY);
+        } else if (rect.Point.X == UpperRight.X && rect.Point.Y == LowerLeft.Y) {
+          point1 = new PointD(LowerLeft.X, LowerLeft.Y + delta.DY);
+          point2 = new PointD(UpperRight.X + delta.DX, UpperRight.Y);
+        }
+        SetPosition(new PointD(Math.Min(point1.X, point2.X), Math.Min(point1.Y, point2.Y)),
+                    new PointD(Math.Max(point1.X, point2.X), Math.Max(point1.Y, point2.Y)));
+      } else SetPosition(LowerLeft + delta, UpperRight + delta);
+    }
+
+    public override void SnapToGrid(IGrid grid) {
+      var bl = grid.GetBottomLeftGridPoint(LowerLeft);
+      var ur = grid.GetUpperRightGridPoint(LowerLeft);
+      var sx = Math.Abs(bl.X - LowerLeft.X) <= Math.Abs(ur.X - LowerLeft.X) ? bl.X : ur.X;
+      var sy = Math.Abs(bl.Y - LowerLeft.Y) <= Math.Abs(ur.Y - LowerLeft.Y) ? bl.Y : ur.Y;
+
+      var end = new PointD(UpperRight.X + (sx - LowerLeft.X), UpperRight.Y + (sy - LowerLeft.Y));
+
+      bl = grid.GetBottomLeftGridPoint(end);
+      ur = grid.GetUpperRightGridPoint(end);
+      var ex = Math.Abs(bl.X - end.X) <= Math.Abs(ur.X - end.X) ? bl.X : ur.X;
+      var ey = Math.Abs(bl.Y - end.Y) <= Math.Abs(ur.Y - end.Y) ? bl.Y : ur.Y;
+
+      SetPosition(new PointD(sx, sy), new PointD(ex, ey));
+    }
+
+    public override void SnapToGrid(PointD point, IGrid grid) {
+      if (Selected && selectionRectangles.ContainsPoint(point)) {
+        var rect = (SelectionRectangle)selectionRectangles.GetPrimitive(point);
+        var point1 = LowerLeft;
+        var point2 = UpperRight;
+        if (rect.Point == LowerLeft) {
+          var bl = grid.GetBottomLeftGridPoint(LowerLeft);
+          var ur = grid.GetUpperRightGridPoint(LowerLeft);
+          var x = Math.Abs(bl.X - LowerLeft.X) <= Math.Abs(ur.X - LowerLeft.X) ? bl.X : ur.X;
+          var y = Math.Abs(bl.Y - LowerLeft.Y) <= Math.Abs(ur.Y - LowerLeft.Y) ? bl.Y : ur.Y;
+          point1 = new PointD(x, y);
+        } else if (rect.Point == UpperRight) {
+          var bl = grid.GetBottomLeftGridPoint(UpperRight);
+          var ur = grid.GetUpperRightGridPoint(UpperRight);
+          var x = Math.Abs(bl.X - UpperRight.X) <= Math.Abs(ur.X - UpperRight.X) ? bl.X : ur.X;
+          var y = Math.Abs(bl.Y - UpperRight.Y) <= Math.Abs(ur.Y - UpperRight.Y) ? bl.Y : ur.Y;
+          point2 = new PointD(x, y);
+        } else if (rect.Point.X == LowerLeft.X && rect.Point.Y == UpperRight.Y) {
+          var upperLeft = new PointD(LowerLeft.X, UpperRight.Y);
+          var bl = grid.GetBottomLeftGridPoint(upperLeft);
+          var ur = grid.GetUpperRightGridPoint(upperLeft);
+          var x = Math.Abs(bl.X - upperLeft.X) <= Math.Abs(ur.X - upperLeft.X) ? bl.X : ur.X;
+          var y = Math.Abs(bl.Y - upperLeft.Y) <= Math.Abs(ur.Y - upperLeft.Y) ? bl.Y : ur.Y;
+          point1 = new PointD(x, LowerLeft.Y);
+          point2 = new PointD(UpperRight.X, y);
+        } else if (rect.Point.X == UpperRight.X && rect.Point.Y == LowerLeft.Y) {
+          var lowerRight = new PointD(UpperRight.X, LowerLeft.Y);
+          var bl = grid.GetBottomLeftGridPoint(lowerRight);
+          var ur = grid.GetUpperRightGridPoint(lowerRight);
+          var x = Math.Abs(bl.X - lowerRight.X) <= Math.Abs(ur.X - lowerRight.X) ? bl.X : ur.X;
+          var y = Math.Abs(bl.Y - lowerRight.Y) <= Math.Abs(ur.Y - lowerRight.Y) ? bl.Y : ur.Y;
+          point1 = new PointD(LowerLeft.X, y);
+          point2 = new PointD(x, UpperRight.Y);
+        }
+        SetPosition(new PointD(Math.Min(point1.X, point2.X), Math.Min(point1.Y, point2.Y)),
+                    new PointD(Math.Max(point1.X, point2.X), Math.Max(point1.Y, point2.Y)));
+      } else SnapToGrid(grid);
     }
 
@@ -86,36 +150,7 @@
     }
 
-    public override void MouseDrag(PointD point, Offset offset, MouseButtons button) {
-      if (button == MouseButtons.Left) {
-        if (Selected) {
-          if (selectionRectangles.ContainsPoint(point)) {
-            SelectionRectangle rect = (SelectionRectangle)selectionRectangles.GetPrimitive(point);
-            PointD point1 = PointD.Empty;
-            PointD point2 = PointD.Empty;
-            if (rect.Point == LowerLeft) {
-              point1 = LowerLeft + offset;
-              point2 = UpperRight;
-            } else if (rect.Point == UpperRight) {
-              point1 = LowerLeft;
-              point2 = UpperRight + offset;
-            } else if ((rect.Point.X == LowerLeft.X) && (rect.Point.Y == UpperRight.Y)) {
-              point1 = new PointD(LowerLeft.X + offset.DX, LowerLeft.Y);
-              point2 = new PointD(UpperRight.X, UpperRight.Y + offset.DY);
-            } else if ((rect.Point.X == UpperRight.X) && (rect.Point.Y == LowerLeft.Y)) {
-              point1 = new PointD(LowerLeft.X, LowerLeft.Y + offset.DY);
-              point2 = new PointD(UpperRight.X + offset.DX, UpperRight.Y);
-            }
-            SetPosition(Math.Min(point1.X, point2.X), Math.Min(point1.Y, point2.Y),
-                        Math.Max(point1.X, point2.X), Math.Max(point1.Y, point2.Y));
-          } else {
-            base.MouseDrag(point, offset, button);
-          }
-        }
-      }
-    }
-
     public override Cursor GetCursor(PointD point) {
       if (Selected) {
-        Cursor cursor = selectionRectangles.GetCursor(point);
+        var cursor = selectionRectangles.GetCursor(point);
         if (cursor != null) return cursor;
       }
@@ -139,23 +174,4 @@
       }
     }
-
-    protected virtual void DrawText(Graphics graphics) {
-      // draw the text in the center of the bounding rectangle
-      var p = Chart.TransformWorldToPixel(new PointD(LowerLeft.X, LowerLeft.Y));
-      var s = Chart.TransformWorldToPixel(Size);
-
-      var stringSize = graphics.MeasureString(Text, Font);
-      var fontSize = (float)(Math.Round(Font.Size * Math.Min(s.Width / stringSize.Width, s.Height / stringSize.Height)));
-      if (fontSize > MaximumFontSize) { fontSize = MaximumFontSize; }
-      Font = new Font(Font.FontFamily, fontSize, GraphicsUnit.Pixel);
-      stringSize = graphics.MeasureString(Text, Font);
-      graphics.DrawString(Text, Font, new SolidBrush(Pen.Color), p.X + (s.Width - stringSize.Width) / 2f, p.Y - (s.Height + stringSize.Height) / 2f);
-    }
-
-    public override void Draw(Graphics graphics) {
-      if (!string.IsNullOrEmpty(Text))
-        DrawText(graphics);
-      base.Draw(graphics);
-    }
   }
 }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/SelectionRectangle.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/SelectionRectangle.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/SelectionRectangle.cs	(revision 13045)
@@ -20,7 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Text;
 using System.Drawing;
 using System.Windows.Forms;
@@ -41,4 +38,7 @@
     }
 
+    public override void SnapToGrid(IGrid grid) { }
+    public override void SnapToGrid(PointD point, IGrid grid) { }
+
     public override Cursor GetCursor(PointD point) {
       return cursor;
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Properties/AssemblyInfo.frame	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Properties/AssemblyInfo.frame	(revision 13045)
@@ -53,4 +53,4 @@
 // You can specify all the values or you can default the Revision and Build Numbers 
 // by using the '*' as shown below:
-[assembly: AssemblyVersion("3.3.0.$WCREV$")]
-[assembly: AssemblyFileVersion("3.3.1.$WCREV$")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.12.$WCREV$")]
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/PropertiesDialog.Designer.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/PropertiesDialog.Designer.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/PropertiesDialog.Designer.cs	(revision 13045)
@@ -74,5 +74,5 @@
       this.AcceptButton = this.okButton;
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.ClientSize = new System.Drawing.Size(506, 306);
       this.Controls.Add(this.propertyGrid);
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/PropertiesDialog.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/PropertiesDialog.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/PropertiesDialog.cs	(revision 13045)
@@ -23,5 +23,4 @@
 using System.Collections.Generic;
 using System.ComponentModel;
-using System.Data;
 using System.Drawing;
 using System.Text;
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Structs/Offset.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Structs/Offset.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Structs/Offset.cs	(revision 13045)
@@ -21,7 +21,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
-using System.Drawing;
 
 namespace HeuristicLab.Visualization {
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Structs/PointD.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Structs/PointD.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Structs/PointD.cs	(revision 13045)
@@ -21,6 +21,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
 using System.Drawing;
 
@@ -86,5 +84,13 @@
     }
     public static bool operator !=(PointD point1, PointD point2) {
-      return (point1.X != point2.X) && (point1.Y != point2.Y);
+      return !(point1 == point2);
+    }
+    public static explicit operator Point(PointD point) {
+      return new Point((int)Math.Round(point.X), (int)Math.Round(point.Y));
+    }
+    public static explicit operator PointF(PointD point) {
+      float fx = (float)point.X;
+      float fy = (float)point.Y;
+      return new PointF(float.IsPositiveInfinity(fx) ? float.MaxValue : fx, float.IsNegativeInfinity(fy) ? float.MinValue : fy);
     }
     public static explicit operator SizeD(PointD point) {
